/* src/main.h - Dclarations principales
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Si vous possdez dj un des services qu'offre ce programme,
 * ou que vous ne souhaitez pas en utiliser un, vous pouvez
 * mettre des // devant la ligne correspondante
 */
#define USE_CHANSERV /* Service des salons [CONSEILL] */
#define USE_WELCOMESERV /* Services des message de bienvenue [] */
#define USE_MEMOSERV /* Services des memos [] */
#define HAVE_CRYPTHOST /* crypter les hosts */
#define HAVE_TRACK /* utiliser le track (permet de monitorer des usernames *louches* */
#define HAVE_VOTE /* utiliser les cmds de vote */
#define N2K 1 /* a activer sur ircoderz ou ircu2.10.11+ (numeric etendue) */

/* sert a desactiver la commande register pour les users, elle devient admin only
 * peut etre utile dans le cas de reg via un bot et un site */
//#define ADMINREG

#ifdef __GNUC__
#if (__GNUC__ < 2) || (__GNUC__ == 2 && __GNUC_MINOR__ < 7)
#define NO_ATTRIBUTE
#endif
#else
#define NO_ATTRIBUTE
#endif

#define DEBUG /* Definir pour debuger log >> desormais log du read/send du socket dans les fichiers */
//#define TESTBOT // Utiliser les fonctions qui sont encore en test
#define SPVERSION "1.1.3"
#define CTCP_DELIM_CHAR '\001'
#define MAXPARA 16
#define MAXLEN 524

#define MAXMEMOS 5 /* par expediteur ie: 5 de Cesar, 5 de Progs etc.. c plus fidle*/
#define MEMOLEN 250 /*Utile  dfinir*/
#define NICKLEN 30 + 1 /* le +1 pour les *LEN est pour compter ici le \0 donc a laisser tel quel.. */
#define CHNICKRAND "Jeux"
#define TOPICLEN 248 + 1
#define HOSTLEN 63 + 1
#define REALEN 50 + 1
#define USERLEN 20 + 1
#define FICHIER_CONF "scoderz.conf"

//si vous ne voulez pas tout logger, mettez rien entre les "" des diffrents fichiers
#define LOG_CMDS "logs/cmds.log" // cmds sur le bot
#define LOG_PARSES "logs/parses.log" // msgs reu du serveur
#define LOG_FAUTH "logs/failed_auth.log" // identification sur username admin chou
#define LOG_CHANS "logs/chans.log" // reg/del/suspend de salons
#define LOG_ERREURS "logs/erreurs.log" // erreurs
#define WAIT_DEL_PARSES 172800 // Temps au bout duquel SCoderZ attend avant de del LOG_PARSES (172800 = 2 jours)
#define WAIT_DEL_LOGS 864000 // Temps au bout duquel SCoderZ attend avant de del les autres fichiers de logs (864000 = 10 jours)
#define USERS_FILE "database/usr.db"
#define USRS_VERSION 13 // version actuelle des fichiers ATTENTION: NE PAS CHANGER risque important de detruire la db
#define BADCHANS_FILE "database/badchans.db"
#define CHANS_FILE "database/chans.db"
#define WELCOME_FILE "database/welcome.db"
#define SETWELCOME_FILE "database/setwelcome.db"
#define BADNICKS_FILE "database/badnicks.db"
#define CMDS_FILE "database/cmds.db"
#define VOTE_FILE "database/votes.db"
#define REGISTER_TIMEOUT 86400 /* temps apres lequel un nick est purge si personne ne s'est auth lors de la procedure de register*/
#define NUMNICKBASE 64
#define PING_FREQ 90 /* interval des pings */
#define ALARMINTERVAL 25 /* interval de l'alarme (si Z rame beaucoup.. l'augmenter)*/

#define WAIT_CONNECT 10 /* Temps qu'attend le serveur avant de retenter une connexion */
#ifdef NO_ATTRIBUTE
#define CVSINFO(id) static char unused_CVSinfo[] = id
#else /* NO_ATTRIBUTE */
#define CVSINFO(id) static char CVSinfo[] __attribute__ ((unused)) = id
#endif /* NO_ATTRIBUTE */
#define IsAnAdmin(x) ((x) && (x)->level > 1) /* x est un admin ? */
#define IsAuthed(x) ((x)->user != NULL) /* x est identifi (real) ? (o x est aNick) */
#define HasMode(x, y) (strchr((x)->modes, (y))) // x = nickinfo, y = char

typedef struct userinfo anUser;
typedef struct nickinfo aNick;
#ifdef USE_MEMOSERV
typedef struct memos aMemo;
#endif
#ifdef USE_CHANSERV
typedef struct chaninfo aChan;
typedef struct access anAccess;
typedef struct baninfo aBan;
typedef struct waitaccess aWaitAccess;
#endif
typedef struct killinfo aKill;
typedef struct badnicks aBadNick;
typedef struct joininfo aJoin;
typedef struct SLink aLink;

#include <structs.h>
#include <proto.h>

#define AOp(x)		 ((x)->flag & A_OP)
#define AVoice(x)	 ((x)->flag & A_VOICE)
#define ASuspend(x)	 ((x)->flag & A_SUSPEND)
#define AProtect(x)	 ((x)->flag & A_PROTECT)
#define SetAOp(x)	 ((x)->flag |= A_OP)
#define SetAVoice(x)	 ((x)->flag |= A_VOICE)
#define SetAProtect(x)	 ((x)->flag |= A_PROTECT)
#define SetASuspend(x)	 ((x)->flag |= A_SUSPEND)
#define DelAOp(x)	 ((x)->flag &= ~A_OP)
#define DelAVoice(x)	 ((x)->flag &= ~A_VOICE)
#define DelAProtect(x)	 ((x)->flag &= ~A_PROTECT)
#define DelASuspend(x)	 ((x)->flag &= ~A_SUSPEND)

#define NRegister(x)	 ((x)->flag & N_REGISTER)
#define SetNRegister(x)	 ((x)->flag |= N_REGISTER)
#define DelNRegister(x)	 ((x)->flag &= ~N_REGISTER)

#define UKill(x)	 ((x)->flag & U_KILL)
#define UProtect(x)	 ((x)->flag & U_PROTECT)
#define UWantDrop(x)	 ((x)->flag & U_WANTDROP)
#define UWantX(x)	 ((x)->flag & U_WANTX)
#define UNopurge(x)	 ((x)->flag & U_NOPURGE)
#define UOubli(x)	 ((x)->flag & U_OUBLI)
#define UFirst(x)	 ((x)->flag & U_FIRST)
#define UNoMemo(x)	 ((x)->flag & U_NOMEMO)
#define SetUKill(x)	 ((x)->flag |= U_KILL)
#define SetUWantX(x)	 ((x)->flag |= U_WANTX)
#define SetUWantDrop(x)	 ((x)->flag |= U_WANTDROP)
#define SetUNopurge(x)	 ((x)->flag |= U_NOPURGE)
#define SetUProtect(x)	 ((x)->flag |= U_PROTECT)
#define SetUOubli(x)	 ((x)->flag |= U_OUBLI)
#define SetUFirst(x)	 ((x)->flag |= U_FIRST)
#define SetUNoMemo(x)	 ((x)->flag |= U_NOMEMO)
#define DelUKill(x)	 ((x)->flag &= ~U_KILL)
#define DelUWantX(x)	 ((x)->flag &= ~U_WANTX)
#define DelUWantDrop(x)	 ((x)->flag &= ~U_WANTDROP)
#define DelUNopurge(x)	 ((x)->flag &= ~U_NOPURGE)
#define DelUProtect(x)	 ((x)->flag &= ~U_PROTECT)
#define DelUOubli(x)	 ((x)->flag &= ~U_OUBLI)
#define DelUFirst(x)	 ((x)->flag &= ~U_FIRST)
#define DelUNoMemo(x)	 ((x)->flag &= ~U_NOMEMO)

#define CSetWelcome(x)		((x)->flag & C_SETWELCOME)
#define CJoined(x)		((x)->flag & C_JOINED)
#define CStrictOp(x)		((x)->flag & C_STRICTOP)
#define CLockTopic(x)		((x)->flag & C_LOCKTOPIC)
#define CNoBans(x)		((x)->flag & C_NOBANS)
#define CWantUnreg(x)		((x)->flag & C_WANTUNREG)
#define CNoOps(x)		((x)->flag & C_NOOPS)
#define CAutoInvite(x)		((x)->flag & C_AUTOINVITE)
#define SetCSetWelcome(x)	((x)->flag |= C_SETWELCOME)
#define SetCJoined(x)		((x)->flag |= C_JOINED)
#define SetCStrictOp(x)		((x)->flag |= C_STRICTOP)
#define SetCLockTopic(x)	((x)->flag |= C_LOCKTOPIC)
#define SetCNoBans(x)		((x)->flag |= C_NOBANS)
#define SetCWantUnreg(x)	((x)->flag |= C_WANTUNREG)
#define SetCNoOps(x)		((x)->flag |= C_NOOPS)
#define DelCSetWelcome(x)	((x)->flag &= ~C_SETWELCOME)
#define DelCJoined(x)		((x)->flag &= ~C_JOINED)
#define DelCStrictOp(x)		((x)->flag &= ~C_STRICTOP)
#define DelCLockTopic(x)	((x)->flag &= ~C_LOCKTOPIC)
#define DelCNoBans(x)		((x)->flag &= ~C_NOBANS)
#define DelCWantUnreg(x)	((x)->flag &= ~C_WANTUNREG)
#define DelCNoOps(x)		((x)->flag &= ~C_NOOPS)

#define NOSUCHUSER "\002%s\002 n'est pas un Username enregistr."
#define NOSUCHAN "\002%s\002 n'est pas un salon enregistr."
#define DEFRAISON "Requested"
#define NOTCONNECTED "%s n'est pas connect."

#ifdef GLOBALS_DEF
struct robot bot;
struct bots ws;
struct bots cs;
/* Les needarg sonts les nombre d'arg minimum requis */

struct cs_commands cs_cmds[] = {
 /* cmd,            function,             niveau, needarg, chan, disable, secure, 0 */
 // Admins
 {  "die",          die,                  "", 4,      0, 0, 0, 0, 0 },
 {  "restart",      restart_bot,          "", 4,      0, 0, 0, 0, 0 },
 {  "rehash",       rehash_conf,          "", 4,      0, 0, 0, 0, 0 },
 {  "addadmin",     do_admin,             "", 4,      2, 0, 0, 0, 0 },
 {  "deladmin",     del_admin,            "", 4,      1, 0, 0, 0, 0 },
 {  "adminlvl",     admin_level,          "", 4,      2, 0, 0, 0, 0 },
 {  "chcomname",    chcomname,            "", 4,      2, 0, 0, 0, 0 },
 {  "chlevel",      chlevel,              "", 4,      2, 0, 0, 0, 0 },
 {  "disable",      disable_cmd,          "", 4,      2, 0, 0, 0, 0 },
#ifdef USE_WELCOMESERV
 {  "setglobwelcome",set_welcome,         "", 3,      0, 0, 0, 0, 0 },
 {  "privmsg",      welcome_privmsg,      "", 3,      0, 0, 0, 0, 0 },
#endif
 {  "inviteme",     inviteme,             "", 2,      0, 0, 0, 0, 0 },
 {  "say",          admin_say,            "", 2,      2, 1, 0, 0, 0 },
 {  "write",        write_files,          "", 2,      0, 0, 0, 0, 0 },
 {  "cswall",       cs_wall,              "", 2,      1, 0, 0, 0, 0 },
 {  "global",       globals_cmds,         "", 2,      2, 0, 0, 0, 0 },
 {  "chan",         admin_chan,           "", 2,      1, 0, 0, 0, 0 },
 {  "reop",         reop,                 "", 2,      0, 0, 0, 0, 0 },
#ifdef HAVE_TRACK
 {  "track",         cmd_track,           "",       3,      1, 0, 0, 0, 0 },
#endif
 {  "user",         admin_user,           "", 2,      2, 0, 0, 0, 0 },
 {  "rdtopics",     rdtopics,             "", 2,      0, 0, 0, 0, 0 },
 {  "rctopics",     rctopics,             "", 2,      0, 0, 0, 0, 0 },
 {  "whoison",      whoison,              "", 2,      1, 0, 0, 0, 0 },
#ifdef HAVE_VOTE
 {  "vote",         do_vote,              "", 3,      0, 0, 0, 0, 0 },
#endif
 /* Users (check with chan access)*/
 {  "unreg",        unreg_chan,           "", 500,    1, 1, 0, 0, 0 },
 {  "renchan",      ren_chan,             "", 500,    2, 1, 0, 0, 0 },
 {  "adduser",      add_user,             "", 450,    3, 1, 0, 0, 0 },
 {  "deluser",      del_user,             "", 450,    2, 1, 0, 0, 0 },
 {  "kickbanall",   kickbanall,           "", 450,    0, 1, 0, 0, 0 },
 {  "kickall",      kickall,              "", 400,    0, 1, 0, 0, 0 },
 {  "opall",        opall,                "", 400,    1, 1, 0, 0, 0 },
 {  "deopall",      deopall,              "", 400,    1, 1, 0, 0, 0 },
 {  "clearmodes",   clearmodes,           "", 400,    0, 1, 0, 0, 0 },
 {  "voiceall",     voiceall,             "", 300,    1, 1, 0, 0, 0 },
 {  "devoiceall",   devoiceall,           "", 300,    1, 1, 0, 0, 0 },
 {  "ban",          ban_cmd,              "", 100,    2, 1, 0, 0, 0 },
 {  "nickban",      nickban,              "", 300,    2, 1, 0, 0, 0 },
 {  "unban",        unban,                "", 300,    2, 1, 0, 0, 0 },
 {  "kickban",      kickban,              "", 300,    2, 1, 0, 0, 0 },
 {  "rdefmodes",    rdefmodes,            "", 300,    1, 1, 0, 0, 0 },
 {  "rdeftopic",    rdeftopic,            "", 300,    1, 1, 0, 0, 0 },
 {  "clearbans",    clear_bans,           "", 300,    0, 1, 0, 0, 0 },
 {  "info",         info,                 "", 100,    0, 1, 0, 0, 0 },
 {  "invite",       invite,               "", 100,    0, 1, 0, 0, 0 },
 {  "op",           op,                   "", 100,    1, 1, 0, 0, 0 },
 {  "deop",         deop,                 "", 100,    1, 1, 0, 0, 0 },
 {  "kick",         kick,                 "", 100,    2, 1, 0, 0, 0 },
 {  "mode",         mode,                 "", 100,    2, 1, 0, 0, 0 },
 {  "topic",        topic,                "", 100,    2, 1, 0, 0, 0 },
 {  "do",           admin_do,             "", 100,    2, 1, 0, 0, 0 },
 {  "devoice",      devoice,              "", 50,     1, 1, 0, 0, 0 },
 {  "voice",        voice,                "", 50,     1, 1, 0, 0, 0 },
 {  "alist",        see_alist,            "", 5,      1, 1, 0, 0, 0 },
 {  "unbanme",      unbanme,              "", 5,      1, 1, 0, 0, 0 },
 // Users (check with nick access)
 {  "listbadchans", list_badchans,        "", 1,      0, 0, 0, 0, 0 },
 {  "myaccess",     myaccess,             "", 1,      0, 0, 0, 0, 0 },
 {  "drop",         drop_user,            "", 1,      1, 0, 0, 2, 0 },
 {  "listbadnicks", list_badnicks,        "", 1,      0, 0, 0, 0, 0 },
 {  "okaccess",     accept_an_access,     "", 1,      2, 1, 0, 0, 0 },
#ifdef HAVE_VOTE
 {  "voter",        voter,                "", 1,      0, 0, 0, 2, 0 },
 {  "results",      vote_results,         "", 1,      0, 0, 0, 0, 0 },
#endif
#ifdef USE_MEMOSERV
 {  "send",         send_memo,            "", 1,      0, 0, 0, 1, 0 },
 {  "memos",        memos,                "", 1,      2, 0, 0, 1, 0 },
#endif
 {  "verify",       verify,               "", 1,      1, 0, 0, 0, 0 },
 {  "hello",        hello_world,          "", 0,      3, 0, 0, 1, 0 },
 {  "register",     register_user,        "", 0,      2, 0, 0, 1, 0 },
 {  "login",        ns_login,             "", 0,      2, 0, 0, 1, 0 },
 {  "recover",      recover,              "", 0,      2, 0, 0, 1, 0 },
 {  "deauth",       deauth,               "", 0,      0, 0, 1, 0, 0 },
 {  "seen",         lastseen,             "", 0,      1, 0, 0, 0, 0 },
 {  "regchan",      register_chan,        "", 0,      2, 0, 0, 0, 0 },
 {  "access",       show_access,          "", 0,      2, 1, 0, 0, 0 },
 {  "aide",         aide,                 "", 0,      0, 0, 0, 0, 0 },
 {  "showcommands", showcommands,         "", 0,      0, 0, 0, 0, 0 },
 {  "uptime",       uptime,               "", 0,      0, 0, 0, 0, 0 },
 {  "banlist",      banlist,              "", 0,      1, 1, 0, 0, 0 },
 {  "copyright",    copyright,            "", 0,      0, 0, 0, 0, 0 },
 {  "admin",        show_admins,          "", 0,      0, 0, 0, 0, 0 },
 {  "whois",        cs_whois,             "", 0,      1, 0, 0, 0, 0 },
 {  "ignorelist",   show_ignores,         "", 0,      0, 0, 0, 0, 0 },
 {  "oubli",        oubli_pass,           "", 0,      2, 0, 0, 0, 0 },
 {  "\001ping",     ctcp_ping,            "", 0,      0, 0, 0, 0, 0 },
 {  "\001version\001", ctcp_version,      "", 0,      0, 0, 0, 0, 0 },
 {  "chaninfo",     chaninfo,      	  "", 0,       1, 1, 0, 0, 0 },
 //moduser
 {  "moduser",      generic_moduser,      "", 450,    3, 1, 0, 0, 0 },
 {  "autoop",       moduser_autoop,       "", 100,    1, 1, 0, 0, 0 },
 {  "autovoice",    moduser_autovoice,    "", 50,     1, 1, 0, 0, 0 },
 {  "protect",      moduser_protect,      "", 100,    1, 1, 0, 0, 0 },
 //chanopt
 {  "locktopic",    locktopic,            "", 400,    0, 1, 0, 0, 0 },
 {  "strictop",     strictop,             "", 450,    0, 1, 0, 0, 0 },
 {  "nobans",       nobans,               "", 450,    0, 1, 0, 0, 0 },
 {  "noops",        noops,                "", 450,    0, 1, 0, 0, 0 },
 {  "deftopic",     deftopic,             "", 400,    1, 1, 0, 0, 0 },
 {  "defmodes",     defmodes,             "", 400,    1, 1, 0, 0, 0 },
 {  "description",  description,          "", 450,    1, 1, 0, 0, 0 },
 {  "welcome",      csetwelcome,          "", 450,    1, 1, 0, 0, 0 },
 {  "setwelcome",   activwelcome,         "", 450,    1, 1, 0, 0, 0 },
 {  "banlevel",     banlevel,             "", 400,    1, 1, 0, 0, 0 },
 {  "bantype",      bantype,              "", 400,    1, 1, 0, 0, 0 },
 {  "chanurl",      chanurl,              "", 450,    1, 1, 0, 0, 0 },
 {  "motd",         define_motd,          "", 450,    1, 1, 0, 0, 0 },
 {  "chanopt",      generic_chanopt,      "", 450,    2, 1, 0, 0, 0 },
// NOUVELLES COMMANDES ICI !
 {  "showconfig",   showconfig,		  "", 4, 	  0, 0, 0, 0, 0 },
 {  "addwelcome",   add_welcome,   	  "", 4, 	  2, 0, 0, 0, 0 },
 {  "delwelcome",   del_welcome,	  "", 4, 	  1, 0, 0, 0, 0 },
 {  "listwelcome",  list_welcome,      	  "", 4,	  0, 0, 0, 0, 0 },
 {  "adminmotd",    set_motds,            "", 4,      2, 0, 0, 0, 0 },
 {  "abad",   badmanage,          "", 3,       2, 0, 0, 0, 0 },
 {  "set",   user_set,          "", 1,       1, 0, 0, 0, 0 },
 {  "",             NULL,                "", 0,      0, 0, 0, 0, 0 }
};

int tuptime = 0;
int premiere = 0;
int tidle;

#else
extern struct robot bot;
extern struct bots ws;
extern struct bots cs;
extern struct nickinfo *nickhead;
extern struct userinfo *userhead;
extern struct chaninfo *chanhead;
extern int tuptime;
extern int tidle;
extern int premiere;
#endif

#define CF_XMODE 0x001
#define CF_ADMINEXEMPT 0x002
#define CF_KILLFORFLOOD 0x004
#define CF_CHANGENICK 0x008
#define CF_HOSTHIDING 0x010
#define CF_WELCOME 0x020
#define CF_PRIVWELCOME 0x040
#define CF_HIDE_ADML4 0x080

#ifdef N2K
#define TOKEN_PRIVMSG "P"
#define TOKEN_PING "G"
#define TOKEN_NICK "N"
#define TOKEN_JOIN "J"
#define TOKEN_PART "L"
#define TOKEN_MODE "M"
#define TOKEN_KICK "K"
#define TOKEN_CREATE "C"
#define TOKEN_QUIT "Q"
#define TOKEN_ACCOUNT "AC"
#define TOKEN_BURST "B"
#define TOKEN_AWAY "A"
#define TOKEN_SERVER "S"
#define TOKEN_SQUIT "SQ"
#define TOKEN_TOPIC "T"
#define TOKEN_KILL "D"
#define TOKEN_WHOIS "W"
#define TOKEN_SETHOST "SETHOST"
#define TOKEN_SETIDENT "SETIDENT"
#define TOKEN_PASS "PASS"
#define TOKEN_EOB "EB"
#define TOKEN_EOBACK "EA"
#define TOKEN_PONG "Z"
#define TOKEN_WALLOPS "WA"
#define TOKEN_NOTICE "O"
#define TOKEN_SVSMODE "SVSMODE"
#define TOKEN_SVSNICK "SVSNICK"
#define TOKEN_INVITE "I"
#else
#define TOKEN_PRIVMSG "PRIVMSG"
#define TOKEN_PING "PING"
#define TOKEN_NICK "NICK"
#define TOKEN_JOIN "JOIN"
#define TOKEN_PART "PART"
#define TOKEN_MODE "MODE"
#define TOKEN_KICK "KICK"
#define TOKEN_CREATE "CREATE"
#define TOKEN_QUIT "QUIT"
#define TOKEN_ACCOUNT "ACCOUNT"
#define TOKEN_BURST "BURST"
#define TOKEN_AWAY "AWAY"
#define TOKEN_SERVER "SERVER"
#define TOKEN_SQUIT "SQUIT"
#define TOKEN_TOPIC "TOPIC"
#define TOKEN_KILL "KILL"
#define TOKEN_WHOIS "WHOIS"
#define TOKEN_SETHOST "SETHOST"
#define TOKEN_SETIDENT "SETIDENT"
#define TOKEN_PASS "PASS"
#define TOKEN_EOB "END_OF_BURST"
#define TOKEN_EOBACK " EOB_ACK"
#define TOKEN_PONG "PONG"
#define TOKEN_WALLOPS "WALLOPS"
#define TOKEN_NOTICE "NOTICE"
#define TOKEN_SVSMODE "SVSMODE"
#define TOKEN_SVSNICK "SVSNICK"
#define TOKEN_INVITE "INVITE"
#endif
