/* src/admin_chan.c - commandes admin pour gerer les salons
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <time.h>
#include "main.h"

void admin_chan(aNick *nick, aChan *chan, int parc, char **parv)
{
	char *c = NULL, raison[300];
	const char *arg = parv[1];
	int i = 0, m = 0;

	if(parc > 1) chan = getchaninfo((c=parv[2]));

	if(!strcasecmp(arg, "suspend"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: CHAN SUSPEND <salon> [arg]");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		if(parc < 3 && chan->suspend[0] == '\0')
		{
			csntc(nick, "Veuillez prciser une raison pour suspendre ce salon.");
			return;
		}
		if(chan->suspend[0] == '\0')
		{
			parv2msgn(parc, parv, 3, chan->suspend, 200);
			csntc(nick, "Salon \002%s\002 suspendu pour: \002%s", c, chan->suspend);
			cspart(c, "%s", chan->suspend);
			putlog(LOG_CHANS, "SUSPEND ON %s par %s@%s (%s)\n", c, nick->nick, nick->user->nick, chan->suspend);
		}
		else
		{
			chan->suspend[0] = '\0';
			csntc(nick, "Le salon \002%s\002 n'est plus suspendu.", c);
			csjoin(chan);
			csmode(chan, "+o %s", cs.num);
			csmode(chan, "%s", chan->defmodes);
			putlog(LOG_CHANS, "SUSPEND OFF %s par %s@%s\n", c, nick->nick, nick->user->nick);
		}
		write_achan(chan);
		return;
	}
	if(!strcasecmp(arg, "del"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: CHAN DEL <salon> <raison>");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		if(parc > 2) parv2msgn(parc, parv, 3, raison, 300);
		else strcpy(raison, "Aucune raison");

		csntc(nick, "Le salon %s a bien t dsenregistr (%s)", c, raison);
		cspart(c, "Salon dsenregistr par %s -\002 %s", nick->nick, raison);
		cswallops("Le salon %s a t supprim par %s -\002 %s", c, nick->user->nick, raison);
		putlog(LOG_CHANS, "CHAN DEL %s par %s@%s (%s)\n", c, nick->nick, nick->user->nick, raison);

		del_chan(c);
		write_chanlist();
		return;
	}
	if(!strcasecmp(arg, "reg"))
	{
		anUser *u;
		int flag = 0;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: CHAN REG <salon> <Username> [description]");
			return;
		}
		if(chan)
		{
			csntc(nick, "%s est dj enregistr.", c);
			return;
		}
		if(!chan_check(c, nick)) return;
		if(!(u=getuserinfo(parv[3])))
		{
			csntc(nick, NOSUCHUSER, parv[3]);
			return;
		}
		if(parc>=4) parv2msgn(parc, parv, 4, raison, 300);
		else strcpy(raison, "Adminreg");
		flag |= (A_OP | A_PROTECT);

		chan = add_chan(c, "+nt", "", raison, "+nt", "", "", 0, "", 0, 0, 0, 0, 100, 1, "", "");
		add_access(u, c, 500, flag, "", time(NULL));
		csjoin(chan);
		csmode(chan, "+ont %s", cs.num);
		append_file(CHANS_FILE,c);
		write_achan(chan);
		write_anuser(u);
		csntc(nick, "%s a t enregistr pour %s.", c, parv[3]);
		return;
	}
	if(!strcasecmp(arg, "list"))
	{
		csntc(nick, "\002\037Liste des salons enregistrs :");
		if(parc < 2) m = 1;

		for(chan=chanhead;chan;chan=chan->next)
		{
			if(m || !match(parv[2], chan->chan))
			{
				csntc(nick, "  %s (%s) %s", chan->chan, chan->defmodes, (chan->suspend[0] != '\0') ? "(\002Supendu\002)" : "");
				i++;
			}
		}
		csntc(nick, "Il y a un total de \002%d\002 salon%s enregistr%s%s", i, i > 1 ? "s" : "", i > 1 ? "s" : "", !m ? " correspondants  la recherche." : ".");
		return;
	}
	if(!strcasecmp(arg, "suspendlist"))
	{
		csntc(nick, "\002\037Liste des salons suspendus :");
		if(parc < 2) m = 1;

		for(chan=chanhead;chan;chan=chan->next)
		{
			if(chan->suspend[0] != '\0' && (m || !match(parv[2], chan->chan)))
			{
				csntc(nick, "  %s raison : %s", chan->chan, chan->suspend);
				i++;
			}
		}
		csntc(nick, "Il y a un total de \002%d\002 salons suspendus correspondant  vos critres.", i);
		return;
	}
	if(!strcasecmp(arg, "join"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: CHAN JOIN <salon>");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		if(chan->suspend[0] != '\0')
		{
			csntc(nick, "%s est actuellement suspendu pour %s, utilisez 'CHAN SUSPEND %s' pour lever le suspend.", c, chan->suspend, c);
			return;
		}
		csjoin(chan);
		csmode(chan, "+o %s", cs.num);
		return;
	}
	if(!strcasecmp(arg, "part"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: CHAN PART <salon> [raison]");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		if(parc > 2) parv2msgn(parc, parv, 3, raison, 300);
		else strcpy(raison, "Aucune Raison");
		cspart(c, "%s", raison);
		return;
	}
	if(!strcasecmp(arg, "newowner"))
	{
		anAccess *access, *new = NULL;
		anUser *user, *newu=NULL;
		int found = 0, flag = 0;

		if(parc <3)
		{
			csntc(nick, "Syntaxe: CHAN NEWOWNER  <chan> <nouvel owner>");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		for(user = userhead;user;user = user->next)
		{
			if(!strcasecmp(user->nick, parv[3]))
			{
				new = GetAccessIbyUserI(user,c);
				newu=user;
				if(new && new->level == 500)
				{
					csntc(nick, "%s est dj l'owner de %s", parv[3], c);
					return;
				}
				found = 1;
			}
			else
			{
				if((access=GetAccessIbyUserI(user,c)) && access->level == 500)
				{
					csntc(nick, "Le salon %s possde dj un owner: %s", c, user->nick);
					csntc(nick, "Pour que %s ne soit plus owner et que %s le devienne, utilisez /%s CHAN CHOWNER %s %s %s", user->nick, parv[3], cs.nick, c, user->nick, parv[3]);
					return;
				}
			}
		}
		if(!found)
		{
			csntc(nick, NOSUCHUSER, parv[3]);
			return;
		}
		if(!new)
		{
			flag |= (A_OP | A_PROTECT);
			add_access(newu, c, 500, flag, "", time(NULL));
		}
		else new->level = 500;
		write_anuser(newu);
		csntc(nick, "%s est maintenant l'owner de %s", parv[3], c);
		return;
	}
	if(!strcasecmp(arg, "chowner"))
	{
		anAccess *old = NULL, *new = NULL;
		anUser *user,*newu=NULL,*lastu=NULL;
		int foundold = 0, foundnew = 0, flag = 0;;

		if(parc <4)
		{
			csntc(nick, "Syntaxe: CHAN CHOWNER  <chan> <owner actuel> <nouvel owner>");
			return;
		}
		if(!strcasecmp(parv[3],parv[4]))
		{
			csntc(nick, "Veuillez prciser un VRAI nouvel owner.");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		for(user = userhead;user;user = user->next)
		{
			if(!strcasecmp(user->nick, parv[3]))
			{
				old = GetAccessIbyUserI(user,c);
				if(!old || old->level != 500)
				{
					csntc(nick, "%s n'est pas l'owner de %s", parv[3], c);
					return;
				}
				lastu=user;
					foundold++;
			}
			if(!strcasecmp(user->nick, parv[4]))
			{
				new = GetAccessIbyUserI(user,c);
				newu=user;
				if(new && new->level == 500)
				{
					csntc(nick, "%s est dj l'owner de %s", parv[4], c);
					return;
				}
				foundnew++;
			}
			if(foundnew && foundold) break;
		}
		if(!foundnew || !foundold)
		{
			if(!foundnew && !foundold) csntc(nick, "\2%s\2 et \2%s\2 ne sont pas des usernames existants.", parv[3], parv[4]);
			else csntc(nick, NOSUCHUSER, !foundnew ? parv[4] : parv[3]);
			return;
		}
		if(!new)
		{
			flag |= (A_OP | A_PROTECT);
			add_access(newu, c, 500, flag, "", time(NULL));
		}
		else new->level = 500;
		del_access(lastu, chan);
		write_anuser(lastu);
		write_anuser(newu);
		csntc(nick, "%s est maintenant l'owner de %s, et %s n'y a plus accs", parv[4], c, parv[3]);
		return;
	}
	csntc(nick, "%s n'est pas une option valide.", arg);
	return;
}

void whoison(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aChan *c;
	aLink *lp = NULL;
	char buf[400], tmp[NICKLEN + 15];
	int got=0;

	buf[0] = '\0';

	if(parc < 1) return; /* sait-on jamais ! */

	if(!(c = getchaninfo(parv[1])))
	{
		csntc(nick, "Le salon \2%s\2 n'est pas un salon enregistr.", parv[1]);
		return;
	}
	lp = c->members;
	while(lp)
	{
		if((strlen(buf) + strlen(lp->value.j->nick->nick)) >= 400)
		{
			csntc(nick, "         %s", buf);
			buf[0]='\0';
			got++;
		}
		else
		{
			snprintf(tmp, (NICKLEN + 15), " %s%s%s%s%s", lp->value.j->nick->is_oper?"\0037\2*\003\2":"",lp->value.j->nick->user?"\0035!\003":"", lp->value.j->is_op ? "@" : "", lp->value.j->is_voice ? "+" : "",lp->value.j->nick->nick);
			strncat(buf, tmp, 400);
		}
		lp=lp->next;
	}
	if(got) csntc(nick, "         %s", buf);
	else if(buf[0]!='\0') csntc(nick, "Users sur %s:%s", parv[1], buf);
	return;
}

void rctopics(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   aChan *chan;

   for(chan=chanhead;chan;chan=chan->next) cstopic(chan, "%s", chan->topic);
   return;
}


void rdtopics(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   aChan *chan;

   for(chan=chanhead;chan;chan=chan->next) cstopic(chan, "%s", chan->deftopic);
   return;
}
