/* src/welcome.c - Diverses commandes sur le module welcome
 * Copyright (C) 2002-2003 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: welcome.c,v 1.2 2003/02/15 14:56:32 romexzf Exp $");

#ifdef USE_WELCOMESERV

extern int ConfFlag;
extern char user_motd[];
extern char admin_motd[];

/*
 * new_welcome
 *
 * parv[1] = message
 *
void new_welcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	parv2msgn(parc, parv, 1, welcome, 400);
	putserv("%s %s %s :\002Bienvenue\002 - %s\n", ws.num, (ConfFlag & CF_PRIVWELCOME) ? TOKEN_PRIVMSG : TOKEN_NOTICE, nick->numeric, welcome);
	if(!(ConfFlag & CF_WELCOME))
		putserv("%s %s %s :\002ATTENTION !\002 Le welcome est inactif.\n", ws.num, (ConfFlag & CF_PRIVWELCOME) ? TOKEN_PRIVMSG : TOKEN_NOTICE, nick->numeric);
	write_welcome();
	return;
}
*/

/*
 * set_welcome
 *
 * parv[1] = on/off
 */
void set_welcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(!parc) ConfFlag = ToggleFlag(ConfFlag, CF_WELCOME);
	else
	{
		if(!strcasecmp(parv[1], "ON")) ConfFlag |= CF_WELCOME;
		else if(!strcasecmp(parv[1], "OFF")) ConfFlag &= ~CF_WELCOME;
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}
	}
	csntc(nick, "Le welcome est maintenant %s", (ConfFlag & CF_WELCOME) ? "activ" : "desactiv");
	write_welcome();
	return;
}

/*
 * welcome_privmsg
 *
 * parv[1] = on/off
 */
void welcome_privmsg(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(!parc) ConfFlag = ToggleFlag(ConfFlag, CF_PRIVWELCOME);
	else
	{
		if(!strcasecmp(parv[1], "ON")) ConfFlag |= CF_PRIVWELCOME;
		else if(!strcasecmp(parv[1], "OFF")) ConfFlag &= ~CF_PRIVWELCOME;
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}
	}
	csntc(nick, "Le welcome est maintenant envoy en %s", (ConfFlag & CF_PRIVWELCOME) ? "privmsg" : "notice");
	write_welcome();
	return;
}

/*
 * see_welcome
 *
void see_welcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(!(ConfFlag & CF_WELCOME) || !welcome || welcome[0] == '\0')
	{
		csntc(nick, "Le message de bienvenue %s", (ConfFlag & CF_WELCOME) ? "inactif" : "n'est pas dfini");
		return;
	}
	putserv("%s %s %s :\002Bienvenue\002 - %s\n", ws.num, (ConfFlag & CF_PRIVWELCOME) ? TOKEN_PRIVMSG : TOKEN_NOTICE, nick->numeric, welcome);
	return;
}
*/

/* /z addwelcome <level> <message> */
extern struct welcomeinfo *welcomehead;

void add_welcome(aNick *nick, aChan *c, int parc, char **parv)
{
	struct welcomeinfo *new, *w;
	int level;

	if(!is_num(parv[1]))
	{
		csntc(nick, "Le niveau doit tre un nombre.");
		return;
	}
	level = atoi(parv[1]);
	if(level < 1 || level > 100)
	{
		csntc(nick, "Le niveau doit etre compris entre 1 et 100");
		return;
	}

	new = (struct welcomeinfo *) calloc(1, sizeof(struct welcomeinfo));
   	if(!new)
   	{
	   	putlog(LOG_ERREURS, "ERREUR MAJEURE: Impossible de malloc de la memoire pour welcomeinfo !\n");
	   	return;
   	}

	w = welcomehead;
	while(w)
	{
		if(!w->next) break;
		else w = w->next;
	}

	new->next = NULL;

	if(!w) new->id = 1; /* bah c'est le 1er */
	else new->id = w->id + 1; /* on incrmente l'id */

	parv2msgn(parc, parv, 2, new->msg, 250);
	new->level = level;

	if(!w) welcomehead = new; /* ben c'est le 1er */
	else w->next = new;

	csntc(nick, "Welcome bien ajout au level %d", level);
	csntc(nick, "\002[Message de bienvenue #%d]\002 - %s", new->id, new->msg);

	write_welcome();
	return;
}

void del_welcome(aNick *nick, aChan *c, int parc, char **parv)
{
	struct welcomeinfo *current = NULL, *previous = NULL;
	int id;

	if(parc < 1) return;
	if(!is_num(parv[1]))
	{
		csntc(nick, "L'id doit tre un nombre.");
		return;
	}
	id = atoi(parv[1]);
	current = welcomehead;

	while(current)
	{
		if(id == current->id) break;
		previous = current;
		current = current->next;
	}
	if(!current)
	{
		csntc(nick, "Aucune message ayant pour id %d", id);
		return;
	}

	if(!previous) welcomehead = current->next; /* ben c'etait le 1er */
	else
	{
		previous->next = current->next;
	}
	free(current);
	current = welcomehead;

	id = 1;
	while(current)
	{
		current->id = id;
		current = current->next;
		id++;
	}
	csntc(nick, "Le message ayant pour id %s a bien t supprim (un total de %d messages dsormais)", parv[1], id - 1);
	write_welcome();
	return;
}

void list_welcome(aNick *nick, aChan *c, int parc, char **parv)
{
	struct welcomeinfo *w;

	if(!welcomehead)
	{
		csntc(nick, "Aucun message de bienvenue");
		return;
	}
	csntc(nick, "\002#Id Level Message");
	for(w=welcomehead;w;w=w->next) csntc(nick, "#%d %d %s", w->id, w->level, w->msg);

	return;
}

#undef RAND_MAX
#define RAND_MAX 99999999
void choose_welcome(char *num)
{
	int rnd;
	struct welcomeinfo *w;

	if(!welcomehead) return;
	rnd = 1;
	while(rnd != 0)
	{
		rnd = rand()%100;
		for(w=welcomehead;w;w=w->next) if(w->level > rnd && rnd%3) break;
		if(w)
		{
			send_welcome(num, w);
			return;
		}
		else rnd--;
	}
	w = welcomehead;
	send_welcome(num, w);
	return;
}

void send_welcome(char *num, struct welcomeinfo *w)
{
	putserv("%s %s %s :\002[Message de bienvenue #%d]\002 - %s\n", ws.num, (ConfFlag & CF_PRIVWELCOME) ? TOKEN_PRIVMSG: TOKEN_NOTICE, num, w->id, w->msg);
	return;
}

void write_welcome()
{
	FILE *fp;
	struct welcomeinfo *w;

	if(!(fp = fopen(WELCOME_FILE, "w"))) return;
	fprintf(fp, "VERSION %d\n", USRS_VERSION);
	fprintf(fp, "%d\n", (ConfFlag & CF_WELCOME));
	fprintf(fp, "%s\n", user_motd);
	fprintf(fp, "%s\n", admin_motd);
	w = welcomehead;
	while(w)
   	{
      	fprintf(fp, "%d :%s\n", w->level, w->msg);
     		w = w->next;
   	}
   	fclose(fp);
   	return;
}

void load_welcome()
{
	char buff[420], *tmp, msg[250];
	int a=0, t=0, fileversion = 1, g;
	FILE *fp;

	if(!(fp = fopen(WELCOME_FILE, "r"))) return;
	while(fgets(buff, 420, fp) != NULL)
   	{
		strip_newline(buff);
		if(!strncmp(buff, "VERSION", 7))
		{
			if((tmp=strchr(buff, ' '))) tmp++;
			fileversion = atoi(tmp);
		}
		else if(t==1 && fileversion>=8) sscanf(buff, "%d",&g);
		else if(t==2 && fileversion>=8) strncpy(user_motd, buff, 390);
		else if(t==3 && fileversion>=8) strncpy(admin_motd, buff, 390);
		else
		{
			tmp = strchr(buff, ':');
	  		if (*tmp == ':') tmp++;
			strncpy(msg, tmp, 250);
			a = atoi(strtok(buff, " "));
			add_loadwelcome(a, msg);
		}
		t++;
	}
	fclose(fp);
	if(fileversion<8)
	{
		if(!(fp = fopen(SETWELCOME_FILE, "r"))) return;
		if(fgets(buff, 420, fp)) sscanf(buff, "%d", &g);
		fclose(fp);
	}
	if(g) ConfFlag |= CF_WELCOME;
	return;
}

void add_loadwelcome(int level, char *msg)
{
	struct welcomeinfo *w, *new;

	new = (struct welcomeinfo *) calloc(1, sizeof(struct welcomeinfo));
   	if(!new)
   	{
	   	putlog(LOG_ERREURS, "ERREUR MAJEURE: Impossible de malloc de la memoire pour welcomeinfo !\n");
	   	return;
   	}

	w = welcomehead;
	while(w)
	{
		if(!w->next) break;
		else w = w->next;
	}

	new->next = NULL;

	if(!w) new->id = 1; /* bah c'est le 1er */
	else new->id = w->id + 1; /* on incrmente l'id */

	strncpy(new->msg, msg, 250);
	new->level = level;

	if(!w) welcomehead = new; /* ben c'est le 1er */
	else w->next = new;

	return;
}
#endif
